beql = LibStub("AceAddon-3.0"):GetAddon("beql")
local beqlQ = beqlQ
local L = LibStub("AceLocale-3.0"):GetLocale("beql")

local OldQuestLogButtonTable
local beqlQuestLogButtonTable

function beql:InitQuestLog()

-- Events
	beql:RegisterEvent("QUEST_PROGRESS")
	beql:RegisterEvent("QUEST_COMPLETE")
  beql:RegisterEvent("QUEST_LOG_UPDATE")
	
	-- Quixout dosn't Fire Events, it now uses callbacks
	beqlQ.RegisterCallback(beql, "Quest_Complete")
	beql:RegisterEvent("Quixote_Leaderboard_Update")

-- Hooks
	-- beql:RawHook("QuestLog_OnShow", "Hooks_QuestLog_OnShow", true)
	-- <event function="*"> are terrible
	-- backup old function
	if not beql.hooks.QuestLog_OnShow then
		beql.hooks.QuestLog_OnShow = QuestLogFrame:GetScript("OnShow")
	end
	QuestLogFrame:SetScript("OnShow", beql.Hooks_QuestLog_OnShow);
	
	-- override updating sequence, need no reset
	-- the old function is a copy of the org script
	-- QuestLogScrollFrame.update = QuestLog_Update
	-- which is a copy oth the org code which wont be hooked if we hook the orginal function
	-- new code calls the orginal or hooked function
	QuestLogScrollFrame.update = function() QuestLog_Update() end

	beql:RawHook("QuestLogTitleButton_OnClick","Hooks_QuestLogTitleButton_OnClick", true)
	beql:RawHook("GetQuestLogTitle","Hooks_GetQuestLogTitle",true)
  beql:RawHook("QuestLog_Update", "Hooks_QuestLog_Update", true)
	
	QuestLogTitleText:SetText(L["Bayi's Extended Quest Log"])

	if not beql.ConfigButton then
		beql.ConfigButton = CreateFrame("Button","ConfigButton", QuestLogFrame, "UIPanelButtonTemplate")
	end
	beql.ConfigButton:SetWidth(15)
	beql.ConfigButton:SetHeight(19)
	beql.ConfigButton:SetText("O")
	beql.ConfigButton:Show()
	beql.ConfigButton:ClearAllPoints()
	beql.ConfigButton:SetPoint("RIGHT",QuestLogFrameCloseButton, "LEFT",0,0)
	beql.ConfigButton:SetScript("OnClick", function()
		InterfaceOptionsFrame_OpenToCategory(beql3.optionsFrames["main"])
	end)
	
	QuestLogFrame:SetScript("OnDragStart",function() QuestLogFrame:StartMoving() end)
	QuestLogFrame:SetScript("OnDragStop",function() QuestLogFrame:StopMovingOrSizing() beql:SavePosition() end)
	QuestLogFrame:SetAlpha(beql.db.profile.QuestLogAlpha)
	QuestLogFrame:SetScale(beql.db.profile.QuestLogScale)
	
	QuestLogFrameShowMapButton:SetScript("OnClick", function(self)
		
		local questID = select(9, GetQuestLogTitle(QuestLogFrame.selectedIndex))
		WorldMap_OpenToQuest(questID, self:GetParent());
		self.texture:SetTexCoord(0.125, 0.875, 0.0625, 0.4375);
	end)
	if not QuestLogExpandButtonFrame then
		
		CreateFrame("Frame", "QuestLogExpandButtonFrame", QuestLogFrame)
		QuestLogExpandButtonFrame:SetHeight(32)
		QuestLogExpandButtonFrame:SetWidth(54)
		QuestLogExpandButtonFrame:Show()
		QuestLogExpandButtonFrame:ClearAllPoints()
		QuestLogExpandButtonFrame:SetPoint("TOPLEFT", QuestLogFrame, "TOPLEFT", 70,-48)
		
		CreateFrame("Button", "QuestLogCollapseAllButton", QuestLogExpandButtonFrame, "QuestLogTitleButtonTemplate")
		QuestLogCollapseAllButton:SetText(ALL)
		QuestLogCollapseAllButton:SetHeight(22)
		QuestLogCollapseAllButton:SetWidth(40)
		QuestLogCollapseAllButton:ClearAllPoints()
		QuestLogCollapseAllButton:SetPoint("TOPLEFT", QuestLogExpandButtonFrame, "TOPLEFT", 0,-2)
		QuestLogCollapseAllButton:Show()
		QuestLogCollapseAllButton.isHeader = 1
		QuestLogCollapseAllButton:SetScript("OnClick", function(self)
			local status
			if self.collapsed then
				status = 0
				self.collapsed = nil
			else
				status = 1
				self.collapsed = true
				QuestLog_SetSelection(0);
			end
				
			for k in pairs(beql.cHeader) do
				beql.cHeader[k] = status
			end
			
			if beql.db.char.saved.minimized then
				beql:Minimize()
			else
				beql:Maximize()
			end
			QuestLog_Update()
			WatchFrame_Update()
		end)
		
		
		QuestLogCollapseAllButton:CreateTexture("QuestLogExpandTabLeft", "BACKGROUND")
		QuestLogExpandTabLeft:SetTexture("Interface\\QuestFrame\\UI-QuestLogSortTab-Left")
		QuestLogExpandTabLeft:ClearAllPoints()
		QuestLogExpandTabLeft:SetPoint("TOPLEFT", QuestLogCollapseAllButton, "TOPLEFT", -6,8)
		QuestLogExpandTabLeft:SetHeight(32)
		QuestLogExpandTabLeft:SetWidth(8)
		QuestLogExpandTabLeft:Show()
		
		QuestLogCollapseAllButton:CreateTexture("QuestLogExpandTabMiddle", "BACKGROUND")
		QuestLogExpandTabMiddle:SetTexture("Interface\\QuestFrame\\UI-QuestLogSortTab-Middle")
		QuestLogExpandTabMiddle:ClearAllPoints()
		QuestLogExpandTabMiddle:SetPoint("LEFT", QuestLogExpandTabLeft, "RIGHT", 0,0)
		QuestLogExpandTabMiddle:SetHeight(32)
		QuestLogExpandTabMiddle:SetWidth(48)
		QuestLogExpandTabMiddle:Show()
		
		QuestLogCollapseAllButton:CreateTexture("QuestLogExpandTabRight", "BACKGROUND")
		QuestLogExpandTabRight:SetTexture("Interface\\QuestFrame\\UI-QuestLogSortTab-Right")
		QuestLogExpandTabRight:ClearAllPoints()
		QuestLogExpandTabRight:SetPoint("LEFT", QuestLogExpandTabMiddle, "RIGHT", 0,0)
		QuestLogExpandTabRight:SetHeight(32)
		QuestLogExpandTabRight:SetWidth(8)
		QuestLogExpandTabRight:Show()
		
		CreateFrame("Button", "QuestLogPartyQuestButton", QuestLogFrame,"UIPanelButtonTemplate")
		QuestLogPartyQuestButton:Show()
		QuestLogPartyQuestButton:SetWidth(150)
		QuestLogPartyQuestButton:SetHeight(21)
		
		QuestLogPartyQuestButton:SetText("Show Party Quests")
		QuestLogPartyQuestButton:ClearAllPoints()
		QuestLogPartyQuestButton:SetPoint("TOPRIGHT", QuestLogFrameCancelButton, "TOPLEFT", 0,0)
		QuestLogPartyQuestButton:SetScript("OnClick", function() 
			if QuestLogPartyQuestFrame:IsVisible() then
				QuestLogPartyQuestFrame:Hide()
				QuestLogScrollFrame:Show()
				QuestLogPartyQuestButton:SetText("Show Party Quests")
			else
				if not QuestLogPartyQuestFrame.buttons then
					HybridScrollFrame_CreateButtons(QuestLogPartyQuestFrame, "QuestLogTitleButtonTemplate");
					
					local buttonheigth = QuestLogPartyQuestFrame.buttons[1]:GetHeight()
					
					HybridScrollFrame_Update(QuestLogPartyQuestFrame, 0 * buttonheigth, #QuestLogPartyQuestFrame.buttons * buttonheigth);
					
					for i=1, #QuestLogPartyQuestFrame.buttons do
				--		QuestLogPartyQuestFrame.buttons[i]:Hide()
						QuestLogPartyQuestFrame.buttons[i]:SetScript("OnEnter", function(self) beql:ShowPartyTooltip(self:GetID(), self) end)
						QuestLogPartyQuestFrame.buttons[i]:SetScript("OnLeave", function(self) GameTooltip:FadeOut() end)
						QuestLogPartyQuestFrame.buttons[i].isHeader = true
						QuestLogPartyQuestFrame.buttons[i]:SetNormalTexture("");
						QuestLogPartyQuestFrame.buttons[i]:SetHighlightTexture("");
					end
				end
				
				beql:Party_Update()
				QuestLogPartyQuestFrame:Show()
				QuestLogScrollFrame:Hide()
				QuestLogPartyQuestButton:SetText("Hide Party Quests")
			end
		end)
		
		CreateFrame("ScrollFrame", "QuestLogPartyQuestFrame", QuestLogFrame, "HybridScrollFrameTemplate")
		CreateFrame("Slider", "QuestLogPartyQuestFrameScrollBar", QuestLogPartyQuestFrame, "HybridScrollBarTemplate")
		QuestLogPartyQuestFrame:SetAllPoints(QuestLogScrollFrame)
		QuestLogPartyQuestFrame.update = function() beql:Party_Update() end
		QuestLogPartyQuestFrame:Hide()
--		QuestLogPartyQuestFrame:SetBackdrop({
--			bgFile="Interface\\Tooltips\\UI-Tooltip-Background",
--			edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", tile = true, edgeSize = 16, tileSize = 16,
--			insets = { left= 4, right = 4, top = 4, bottom = 4 }
--		})

	end
	
	-- move to the middle of the Frame
	-- QuestLogCount:SetPoint("TOPLEFT", QuestLogFrame,"TOPLEFT",250,-41)
	-- QuestLogCount: x80 y-41
	QuestLogFrame:SetMovable(true)
end

function beql:ShowPartyTooltip(id, frame)
	if id == 0 then return end
	GameTooltip:ClearLines()
	GameTooltip:SetOwner(frame,"ANCHOR_BOTTOM",0,0)
	GameTooltip:SetHyperlink("quest:" .. tostring(id))
	GameTooltip:AddLine(" ")
	GameTooltip:AddLine("Questid" .. tostring(id))
	GameTooltip:Show()
end

function beql:ExtendedQuestLog()
		
	-- Code from DoubleWide by Iriel
	-- {
	QuestLogFrame:SetAttribute("UIPanelLayout-width", 680)
--	QuestLogFrame:SetWidth(718)
--	QuestLogFrame:SetWidth(71)
	QuestLogFrame:SetHeight(522)
	QuestLogDetailScrollFrame:ClearAllPoints()
	QuestLogDetailScrollFrame:SetPoint("TOPLEFT", QuestLogListScrollFrame, "TOPRIGHT", 34, 0)
	QuestLogDetailScrollFrame:SetHeight(410)
	QuestLogScrollFrame:SetHeight(410)

	if not beql.MinimizeButton then
		beql.MinimizeButton = CreateFrame("Button","MinimizeButton", QuestLogFrame, "UIPanelButtonTemplate")
	end
	
	-- backup old buttons, usa a blizzard function from UIParent.lua
	OldQuestLogButtonTable = CopyTable(QuestLogScrollFrame.buttons)

	
	if not beqlQuestLogButtonTable or type(beqlQuestLogButtonTable) ~= 'table' then
		-- create a new button cache
		HybridScrollFrame_CreateButtons(QuestLogScrollFrame, "QuestLogTitleButtonTemplate");
	else
		-- copy over beql button cache
		QuestLogScrollFrame.buttons = CopyTable(beqlQuestLogButtonTable)
	end
	
--[[	local oldQuestsDisplayed = QUESTS_DISPLAYED
	QUESTS_DISPLAYED = 27
	local oldbutton = getglobal("QuestLogTitle" .. oldQuestsDisplayed)
	for i = oldQuestsDisplayed + 1, QUESTS_DISPLAYED do
		-- parent is not QuestLogFrame, otherwise hiding will not work to 100%
		local button = CreateFrame("Button", "QuestLogTitle" .. i, MinimizeButton, "QuestLogTitleButtonTemplate")
		button:SetID(i)
		button:Hide()
		button:ClearAllPoints()
		button:SetPoint("TOPLEFT", oldbutton, "BOTTOMLEFT", 0, 1)
		oldbutton = button;  -- use old button to speed this up
	end--]]

	local regions = { QuestLogFrame:GetRegions() }

	local xOffsets = { Left = 0; Middle = 256; Right = 512; }
	local yOffsets =  { Top = 0; Bot = -256; }

	local textures = {
		TopLeft = "Interface\\AddOns\\beql\\Images\\topleft",
		TopMiddle = "Interface\\AddOns\\beql\\Images\\topmid_on",
		TopRight = "Interface\\AddOns\\beql\\Images\\topright",

		BotLeft = "Interface\\AddOns\\beql\\Images\\botleft",
		BotMiddle = "Interface\\AddOns\\beql\\Images\\botmid_on",
		BotRight = "Interface\\AddOns\\beql\\Images\\botright",
		
		Icon = "Interface\\Addons\\beql\\Images\\icon",
	}

	-- we refeence the artworks in an array, 
	-- to access them faster by switch
	-- Key's are: TopLeft TopMiddle TopRight BotLeft BotMiddle BotRight and Icon
	if not beql.questlogframes then
		beql.questlogframes = {}
	
		-- get existing textures
		local PATTERN = "^Interface\\QuestFrame\\UI%-QuestLogDualPane%-(([A-Za-z]+))$"
		for _, region in ipairs(regions) do
			if region:IsObjectType("Texture") then
				local texturefile = region:GetTexture()

				if texturefile == "Interface\\QuestFrame\\UI-QuestLog-BookIcon" then
					beql.questlogframes.Icon = region
				end
				local which = texturefile:match(PATTERN)
				if which then
	--				print(" back up " .. texturefile)
--					beql:printpoints(region)
					region:Hide()
					beql.questlogframes[which] = region;
				end
					
				xofs = xofs and xOffsets[xofs]
				yofs = yofs and yOffsets[yofs]
				if xofs and yofs and textures[which] then
--					print(which)
					beql.questlogframes[which] = region;
				end
			end
		end

		for name, path in pairs(textures) do
			local yofs, xofs = name:match("^([A-Z][a-z]+)([A-Z][a-z]+)$")
			xofs = xofs and xOffsets[xofs]
			yofs = yofs and yOffsets[yofs]
			if (xofs and yofs) and not beql.questlogframes[name] then
				beql.questlogframes[name] = QuestLogFrame:CreateTexture(nil, "ARTWORK")
			end
		end
	end

	for name, region in pairs(beql.questlogframes) do
		local yofs, xofs = name:match("^([A-Z][a-z]+)([A-Z][a-z]+)$")
		xofs = xofs and xOffsets[xofs]
		yofs = yofs and yOffsets[yofs]
		if (xofs and yofs) then
				region:ClearAllPoints()
				region:SetPoint("TOPLEFT", QuestLogFrame, "TOPLEFT", xofs, yofs)
				region:SetTexture(textures[name])
				region:SetWidth(256)
				region:SetHeight(256)
				region:Show()
		else
			if name == "Icon" then
				region:SetTexture(textures[name])
			else
				region:Hide()--print("Oops, something wrong with textur " .. name)
			end
		end
	end
	-- }
	-- Code from DoubleWide by Iriel, mod by angelike @ wowace.com
--	QuestLogFrameCloseButton:SetPoint("TOPRIGHT", QuestLogFrame, "TOPRIGHT", -20,-10)
	beql.MinimizeButton:SetNormalTexture("Interface\\AddOns\\beql\\Images\\minimize_up")
	beql.MinimizeButton:SetPushedTexture("Interface\\AddOns\\beql\\Images\\minimize_down")
	beql.MinimizeButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight")
	beql.MinimizeButton:SetWidth(24)
	beql.MinimizeButton:SetHeight(24)
	beql.MinimizeButton:Show()
	beql.MinimizeButton:ClearAllPoints()
	beql.MinimizeButton:SetPoint("RIGHT",QuestLogFrameCloseButton, "LEFT", 0,5)
	beql.MinimizeButton:SetScript("OnClick", 
		function() 
			if beql.db.char.saved.minimized then 
				beql:Maximize() 
			else 
				beql:Minimize() 
			end 
		end
	)
	
	beql.ConfigButton:SetPoint("RIGHT",QuestLogFrameCloseButton, "LEFT",-22,0)
	
end

function beql:SimpleQuestlog()
	if not beql.questlogframes then
		-- Extended Questlog not loaded, return
		return;
	end
	
	-- restore old sizes an points
	QuestLogFrame:SetAttribute("UIPanelLayout-width", nil)
	QuestLogFrame:SetWidth(680)
	QuestLogFrame:SetHeight(447)
--	QuestLogDetailScrollFrame:ClearAllPoints()
--	QuestLogDetailScrollFrame:SetPoint("TOPLEFT", QuestLogScrollFrame, "BOTTOMLEFT", 0, -7)
--	QuestLogDetailScrollFrame:SetHeight(260)
	QuestLogScrollFrame:SetHeight(335)

--	QUESTS_DISPLAYED = 6

	-- restore old textures
	local xOffsets = { Left = 0; Middle = nil; Right = 256; }
	local yOffsets =  { Top = 0; Bot = -256; }

	local textures = {
		-- Top Textures
		TopLeft = "Interface\\QuestFrame\\UI-QuestLog-TopLeft",
		TopRight = "Interface\\QuestFrame\\UI-QuestLog-TopRight",
		
		-- Bottom Textures
		BotLeft = "Interface\\QuestFrame\\UI-QuestLog-BotLeft",
		BotRight = "Interface\\QuestFrame\\UI-QuestLog-BotRight",
		
		-- Icon Texture
		Icon = "Interface\\QuestFrame\\UI-QuestLog-BookIcon",
	}

	-- processing texturfiles
	for name, region in pairs(beql.questlogframes) do
		if name == "Icon" then
			region:SetTexture(textures[name])
		elseif name == 'Left' or name == 'RIGHT' then
			region:Show()
		else
			-- hide other textures
			region:Hide()
		end
	end

	-- hide MinimizeButton will also hide QuestLogTitles 7-27
	beql.MinimizeButton:Hide()

	beql.ConfigButton:ClearAllPoints()
	beql.ConfigButton:SetPoint("RIGHT",QuestLogFrameCloseButton, "LEFT",0,0)
	--QuestLogFrameCloseButton:SetPoint("TOPRIGHT",QuestLogFrame , "TOPRIGHT",-30,-8)
end

function beql:ToggleQuestlogStyle(style)
	beql.db.profile.simplequestlog = style;
	
	if not beql.db.profile.simplequestlog then
		beql:ExtendedQuestLog();
	else
		beql:SimpleQuestlog();
	end
	beql:SetQuestLogFontSize(beql.db.profile.QuestLogFontSize);
	QuestLog_Update();
end

function beql:Minimize()
	beql.db.char.saved.minimized = true 
	if beql.db.profile.simplequestlog then
		return
	end
	beql.ConfigButton:SetPoint("RIGHT",QuestLogFrameCloseButton, "LEFT",-19,0)	
	beql.MinimizeButton:SetPoint("RIGHT",QuestLogFrameCloseButton, "LEFT", 3,5)		
	beql.MinimizeButton:SetNormalTexture("Interface\\AddOns\\beql\\Images\\restore_up")
	beql.MinimizeButton:SetPushedTexture("Interface\\AddOns\\beql\\Images\\restore_down")
	QuestLogDetailScrollFrame:Hide()
	QuestLogFrame:SetAttribute("UIPanelLayout-width", 390)
	QuestLogFrame:SetWidth(353)
	local regions = { QuestLogFrame:GetRegions() }	
	for _, region in ipairs(regions) do
		if region:IsObjectType("Texture") then
			local texturefile = region:GetTexture()
			if texturefile == "Interface\\AddOns\\beql\\Images\\topmid_on" then
				region:SetTexture("Interface\\AddOns\\beql\\Images\\topmid_off")
			end
			if texturefile == "Interface\\AddOns\\beql\\Images\\botmid_on" then
				region:SetTexture("Interface\\AddOns\\beql\\Images\\botmid_off")
			end			
			if texturefile == "Interface\\AddOns\\beql\\Images\\botright" then
				region:SetTexture("Interface\\AddOns\\beql\\Images\\botright_off")
			end	
			if texturefile == "Interface\\AddOns\\beql\\Images\\topright" then
				region:SetTexture("Interface\\AddOns\\beql\\Images\\topright_off")
			end				
		end
	end
	QuestLogControlPanel:Hide()
	
	SHOW_QUEST_OBJECTIVES_ON_MAP = nil
	QuestLogFrameShowMapButton:Hide()
end

function beql:Maximize()
	beql.db.char.saved.minimized = false 
	if beql.db.profile.simplequestlog then
		return
	end	
	local numEntries, _ = GetNumQuestLogEntries()
	if ( numEntries == 0 ) then
		return	
	end
	beql.ConfigButton:SetPoint("RIGHT",QuestLogFrameCloseButton, "LEFT",-22,0)	
	beql.MinimizeButton:SetPoint("RIGHT",QuestLogFrameCloseButton, "LEFT", 0,5)	
	beql.MinimizeButton:SetNormalTexture("Interface\\AddOns\\beql\\Images\\minimize_up")
	beql.MinimizeButton:SetPushedTexture("Interface\\AddOns\\beql\\Images\\minimize_down")
	QuestLogDetailScrollFrame:Show()
	QuestLogFrame:SetAttribute("UIPanelLayout-width", 680)
	--QuestLogFrame:SetWidth(718)
	QuestLogFrame:SetWidth(682)

	local regions = { QuestLogFrame:GetRegions() }		
	for _, region in ipairs(regions) do
		if region:IsObjectType("Texture") then
			local texturefile = region:GetTexture()
			if texturefile == "Interface\\AddOns\\beql\\Images\\topmid_off" then
				region:SetTexture("Interface\\AddOns\\beql\\Images\\topmid_on")
			end
			if texturefile == "Interface\\AddOns\\beql\\Images\\botmid_off" then
				region:SetTexture("Interface\\AddOns\\beql\\Images\\botmid_on")
			end
			if texturefile == "Interface\\AddOns\\beql\\Images\\botright_off" then
				region:SetTexture("Interface\\AddOns\\beql\\Images\\botright")
			end
			if texturefile == "Interface\\AddOns\\beql\\Images\\topright_off" then
				region:SetTexture("Interface\\AddOns\\beql\\Images\\topright")
			end
		end
	end
	QuestLogControlPanel:Show()
	
	SHOW_QUEST_OBJECTIVES_ON_MAP = "1"
	QuestLogFrameShowMapButton:Show()
	QuestLogFrameShowMapButton:SetAlpha(0.25)
end

function beql:SavePosition()
	local Left = QuestLogFrame:GetLeft()
	local Top = QuestLogFrame:GetTop()
	if Left and Top then
		beql.db.char.saved.qlogposx = Left
		beql.db.char.saved.qlogposy = Top
	end
end

function beql:Quest_Complete(event, questname, uid)
	if beql.db.profile.InfoOnQuestCompletion then
		UIErrorsFrame:AddMessage(questname.." "..L["Completed!"], 1.0, 0.8, 0.0, 1.0, UIERRORS_HOLD_TIME)
		if beql.db.profile.InfoSound and beql.db.profile.InfoSound ~= "" then 
			PlaySoundFile(beql.db.profile.InfoSound)
		end
	end

end
--
-- EVENTS --
--

function beql:QUEST_PROGRESS()
	if beql.db.profile.autocomplete then
		CompleteQuest()
	end
end

function beql:QUEST_COMPLETE()
	if beql.db.profile.autocomplete and GetNumQuestChoices() == 0 then
		GetQuestReward(QuestFrameRewardPanel.itemChoice)
	end	
end

function beql:Quixote_Quest_Complete(questname)
	if beql.db.profile.InfoOnQuestCompletion then
		UIErrorsFrame:AddMessage(questname.." "..L["Completed!"], 1.0, 0.8, 0.0, 1.0, UIERRORS_HOLD_TIME)
		if beql.db.profile.InfoSound and beql.db.profile.InfoSound ~= "" then 
			PlaySoundFile(beql.db.profile.InfoSound)
		end
	end
end

function beql:Quixote_Leaderboard_Update(questname, id, lid, description, numHad, numGot, numNeeded, type)
	if beql.db.profile.AnnounceQuest and GetNumPartyMembers() > 0 then
		local chatType = "PARTY"	
		local text = ""
		local objText = ""
		local qstatus
		if type == "item" or type == "monster" or type == "reputation" then
			objText = objText..": "..numGot.."/"..numNeeded
		end		
		text = description..objText
		SendChatMessage(text, chatType)
		_,_,_,_,qstatus = beqlQ:GetQuestByName(questname)
		if numGot == numNeeded and (qstatus == 1) then
			SendChatMessage(questname.." "..L["Completed!"], chatType)
		end		
	end
end

function beql:QUEST_LOG_UPDATE()
	if(beqlfu) then
	  local _,questEntries = GetNumQuestLogEntries()
	  --beqlfu:SetFuBarText(questEntries.."/25")
		beqlfu:UpdateFuBarPluginSettings()
	end
end


-- 
-- Hooks
--

function beql:Hooks_QuestLogTitleButton_OnClick(this, mousebutton)
	-- Add control click
	if beql.db.char.saved.minimized and not this.isHeader then
		beql:Maximize()
	end
	
	-- virtual collapse header
	if not beql.cHeader then
		beql.cHeader = {}
	end
	
	if this.isHeader and ( not IsShiftKeyDown() ) then
		if beql.cHeader[this:GetText()] == 1 then
			beql.cHeader[this:GetText()] = 0
		else
			beql.cHeader[this:GetText()] = 1
		end
	end
	
	local questName = this:GetText()
	local questIndex = this:GetID()-- + HybridScrollFrame_GetOffset(QuestLogScrollFrame);
	
	if mousebutton == "LeftButton" then
		if not IsShiftKeyDown() and IsControlKeyDown()  then
			if ChatFrameEditBox:IsVisible() then
				-- add status to quest to chat (oldstyle)
				beql:AddQuestStatusToChatFrame(questIndex)
			end			
		end
		
		if IsShiftKeyDown()  then
				local questLogTitleText, isHeader, isCollapsed, firstTrackable, lastTrackable, numTracked, numUntracked
				lastTrackable = -1
				numTracked = 0
				numUntracked = 0
				local track = false
				-- check tracked status
				if  this.isHeader  then
					for i=1, GetNumQuestLogEntries(), 1 do
						questLogTitleText, _, _, _, isHeader, isCollapsed = GetQuestLogTitle(i)
						if  questLogTitleText == questName  then
							track = true
							firstTrackable = i+1
						elseif ( track ) then
							if  not isHeader  then
								if IsQuestWatched(i)  then
									numTracked = numTracked+1
									RemoveQuestWatch(i)
								else
									numUntracked = numUntracked+1
									RemoveQuestWatch(i)
								end
							end
							if  isHeader and questLogTitleText ~= questName  then
								lastTrackable = i-1
								break
							end
						end
					end
					if  lastTrackable == -1  then
						lastTrackable = GetNumQuestLogEntries()
					end
					if  numUntracked == 0  then
						-- Untrack all
						for i=firstTrackable, lastTrackable, 1 do
							RemoveQuestWatch(i)
						end
						WatchFrame_Update()
					else
						-- Track all
						for i=firstTrackable, lastTrackable, 1 do
							AddQuestWatch(i)
							-- Set an error message if trying to show too many quests
							if ( GetNumQuestWatches() >= MAX_WATCHABLE_QUESTS ) then
								UIErrorsFrame:AddMessage(format(QUEST_WATCH_TOO_MANY, MAX_WATCHABLE_QUESTS), 1.0, 0.1, 0.1, 1.0)
								break
							end
						end
						WatchFrame_Update()
					end
					QuestLog_Update()
				end
		end
	end
	
	--
	-- Original QuestLogTitleButton_OnClick(button) (altered)
	--
	
--	local questName = this:GetText()
--	local questIndex = this:GetID() + FauxScrollFrame_GetOffset(QuestLogListScrollFrame)
	if ( IsShiftKeyDown() ) then
		-- If header then return
		if ( this.isHeader ) then
			return
		end
		-- Otherwise try to track it or put it into chat
		if ( ChatFrameEditBox:IsVisible() ) then
			--ChatFrameEditBox:Insert(strsub(strtrim(this:GetText()),11))
			local questLink = GetQuestLink(questIndex);
			if ( questLink ) then
				ChatEdit_InsertLink(questLink);
			else
				ChatFrameEditBox:Insert(gsub(this:GetText(), " *(.*)", "%1"))
			end
		else
			-- Shift-click toggles quest-watch on this quest.
			if ( IsQuestWatched(questIndex) ) then
				RemoveQuestWatch(questIndex)
				WatchFrame_Update()
			else
				-- Set an error message if trying to show too many quests
				if ( GetNumQuestWatches() >= MAX_WATCHABLE_QUESTS ) then
					UIErrorsFrame:AddMessage(format(QUEST_WATCH_TOO_MANY, MAX_WATCHABLE_QUESTS), 1.0, 0.1, 0.1, 1.0)
					return
				end
				AddQuestWatch(questIndex)
				QuestLog_Update()
				WatchFrame_Update()
			end
		end
	end
	
	-- Quest History Love :)
	if (IsAltKeyDown() and QuestHistoryFrame) then -- questhistory
		if (mousebutton == "LeftButton") then
			QuestHistoryFrameSearchEditBox_OnEnterPressed_External(questName)
		end
	end	
	
	-- only select quests, no headers
	if not this.isHeader then
		QuestLog_SetSelection(questIndex)
--	if IsAddOnLoaded("Lightheaded") then
--		LightHeaded:QuestLogTitleButton_OnClick(frame, button)
--	end
	end
	QuestLog_Update()
	
	-- make sure that Quixote get's his Data
--	beqlQ.frame:QUEST_LOG_UPDATE()
--	WatchFrame_Update();
--	WatchFrame_Update();
end

function beql:Hooks_QuestLog_OnShow(self)
	securecall(beql.hooks.QuestLog_OnShow)
	QuestLog_Update()
	
	QuestLogDetailScrollFrame:SetHeight(410)
	
	if beql.db.char.saved.qlogposx and beql.db.char.saved.qlogposy then
		QuestLogFrame:ClearAllPoints()
		QuestLogFrame:SetPoint("TOPLEFT","UIParent", "BOTTOMLEFT", beql.db.char.saved.qlogposx, beql.db.char.saved.qlogposy)
	end
		
	if beql.db.char.saved.minimized or beql.db.profile.alwaysminimize or GetQuestLogSelection() == 0 then
		beql:Minimize()
	end
	if beql.db.profile.alwaysmaximize then
		beql:Maximize()
	end
end

function beql:Hooks_GetQuestLogTitle(...)
	local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, uid = beql.hooks.GetQuestLogTitle(...)

	if beql.db.profile.showlevel and questLogTitleText and level and level > 0 and not isHeader and beql.AddTags then
		if  questTag == GROUP then
			if suggestedGroup > 0 then
				questLogTitleText = "["..  level .. "G" .. suggestedGroup .. "]" .. questLogTitleText
			else
				questLogTitleText = "["..  level .. "G] " .. questLogTitleText
			end
		elseif  questTag == ELITE  then
			questLogTitleText = "[" .. level .. "+] " .. questLogTitleText
		elseif  questTag == DUNGEON_DIFFICULTY2 then
			questLogTitleText = "[" .. level .. "H] " .. questLogTitleText
		elseif  questTag == RAID  then
			questLogTitleText = "[" .. level .. "R] " .. questLogTitleText
		elseif  questTag == PVP  then
			questLogTitleText = "[" .. level .. "P] " .. questLogTitleText
		elseif isDaily then
			questLogTitleText = "[" .. level .. "Y] " .. questLogTitleText
		elseif  questTag == LFG_TYPE_DUNGEON  then
			questLogTitleText = "[" .. level .. "D] " .. questLogTitleText
		else
			questLogTitleText = "[" .. level .. "] " .. questLogTitleText
		end
	end
	
	return questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, uid
end

function beql:Hooks_QuestLogCollapseAllButton_OnClick(this)
	print(this:GetName())
	--beql.hooks.QuestLogCollapseAllButton_OnClick(this)
	if beql.db.char.saved.minimized then
		beql:Minimize()
	else
		beql:Maximize()
	end
	QuestLog_Update()
	
	-- make sure that Quixote get's his Data
	beqlQ.frame:QUEST_LOG_UPDATE()
	WatchFrame_Update()
end

function beql:Hooks_QuestLog_Update()

	if GetQuestLogSelection() ~= 0 then
		QuestLogDetailFrame_AttachToQuestLog();
		QuestLogDetailScrollFrame:SetHeight(410)
	else
		QuestLogDetailFrame_DetachFromQuestLog();
	end
	beql.AddTags = true
--	securecall(beql.hooks.QuestLog_Update)

	-- prepare entries
	-- questtable contains the real id's for the quest
	-- real questindex = questtable[unreal quest index]
	local questtable = {}
	local title, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily;
	local LineNr = 1
	local CollapsedHeader = 0
	local addquests = true
	local NumHeader = 0
		
	for i=1, GetNumQuestLogEntries(), 1 do
		title, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily = GetQuestLogTitle(i);
		if ( isHeader ) then
			NumHeader = NumHeader + 1;
			-- dump header data
			if not beql.cHeader[title] then
				if isCollapsed then
					beql.cHeader[title] = 1
					CollapsedHeader = CollapsedHeader +1
				else
					beql.cHeader[title] = 0
				end
			end
			
			if beql.cHeader[title] == 1 then
				addquests = nil
			else
				addquests = true
			end
			
			table.insert(questtable,i)
		elseif( addquests ) then
			table.insert(questtable,i)
		end
	end

	if CollapsedHeader > 0 then
		-- we have real collapsed headers, expand all
		ExpandQuestHeader(0);
		-- no update needed, because we get the event QUEST_LOG_UPDATE
		return
	end

	-- set Collapse all texture
	if #questtable == NumHeader then
		--function QuestLogCollapseAllButton_OnClick(self)
		QuestLogCollapseAllButton.collapsed = 1;
		QuestLogCollapseAllButton:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
	else
		QuestLogCollapseAllButton.collapsed = nil;
		QuestLogCollapseAllButton:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up"); 
	end
--
-- org script
--
	local numEntries = #questtable
	local _, numQuests = GetNumQuestLogEntries();
	if ( numEntries == 0 ) then
		HideUIPanel(QuestLogDetailFrame);
		QuestLogDetailFrame.timeLeft = nil;
		EmptyQuestLogFrame:Show();
		EmptyQuestLogFrame:SetHeight(460)
		QuestLog_SetSelection(0);
	else
		EmptyQuestLogFrame:Hide();
	end

	QuestLog_UpdateMapButton();
	
	-- Update Quest Count
	QuestLog_UpdateQuestCount(numQuests);

	-- If no selection then set it to the first available quest
	local questLogSelection = GetQuestLogSelection();
	local haveSelection = questLogSelection ~= 0;
	if ( numQuests > 0 and not haveSelection ) then
		if ( QuestLogFrame.selectedIndex ) then
			QuestLog_SetNearestValidSelection();
		else
			QuestLog_SetFirstValidSelection();
		end
		questLogSelection = GetQuestLogSelection();
	end
	QuestLogFrame.selectedIndex = questLogSelection;

	-- hide the details if we don't have a selected quest
	if ( not haveSelection ) then
		HideUIPanel(QuestLogDetailFrame);
	end

	-- update the group timer
	local haveGroup = GetNumPartyMembers() > 0 or GetNumRaidMembers() > 1;
	if ( haveGroup ) then
		QuestLogFrame.groupUpdateTimer = 0;
	else
		QuestLogFrame.groupUpdateTimer = nil;
	end

	-- hide the highlight frame initially, it may be shown when we loop through the quest listing if a quest is selected
	QuestLogHighlightFrame:Hide();

	-- Update the quest listing
	local buttons = QuestLogScrollFrame.buttons;
	local numButtons = #buttons;
	local scrollOffset = HybridScrollFrame_GetOffset(QuestLogScrollFrame);
	local buttonHeight = buttons[1]:GetHeight();
	local displayedHeight = 0;

	local numPartyMembers = GetNumPartyMembers();
	local questIndex, questLogTitle, questTitleTag, questNumGroupMates, questNormalText, questCheck;
	local color;
	local partyMembersOnQuest, tempWidth, textWidth;
	
	for i=1, numButtons do
		questLogTitle = buttons[i];
		questIndex = questtable[i + scrollOffset]; -- get real questindex
		questTitleTag = questLogTitle.tag;
		questNumGroupMates = questLogTitle.groupMates;
		questCheck = questLogTitle.check;
		questNormalText = questLogTitle.normalText;
		if ( (i + scrollOffset) <= numEntries ) then
			questLogTitle:SetID(questIndex);
			title, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily = GetQuestLogTitle(questIndex);

			if ( isHeader ) then
				-- set the title
				if ( title ) then
					questLogTitle:SetText(title);
				else
					questLogTitle:SetText("");
				end
	
				-- overwrite collapsed status
				if beql.cHeader[title] == 1 then
					isCollapsed = 1
				end
	
				-- set the normal texture based on the header's collapsed state
				if ( isCollapsed ) then
					questLogTitle:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
				else
					questLogTitle:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up"); 
				end
				questLogTitle:SetHighlightTexture("Interface\\Buttons\\UI-PlusButton-Hilight");

				questNumGroupMates:Hide();
				questTitleTag:Hide();
				questCheck:Hide();
			else
				-- set the title
				if ( ENABLE_COLORBLIND_MODE == "1" ) then
					title = "["..level.."] " .. title;
				end
				questLogTitle:SetText("  "..title);

				-- this isn't a header, hide the header textures
				questLogTitle:SetNormalTexture("");
				questLogTitle:SetHighlightTexture("");

				-- If not a header see if any nearby group mates are on this quest
				partyMembersOnQuest = 0;
				for j=1, numPartyMembers do
					if ( IsUnitOnQuest(questIndex, "party"..j) ) then
						partyMembersOnQuest = partyMembersOnQuest + 1;
					end
				end
				if ( partyMembersOnQuest > 0 ) then
					questNumGroupMates:SetText("["..partyMembersOnQuest.."]");
					questNumGroupMates:Show();
				else
					questNumGroupMates:Hide();
				end

				-- figure out which tag to show, if any
				if ( isComplete and isComplete < 0 ) then
					questTag = FAILED;
				elseif ( isComplete and isComplete > 0 ) then
					questTag = COMPLETE;
				elseif ( isDaily ) then
					if ( questTag ) then
						questTag = format(DAILY_QUEST_TAG_TEMPLATE, questTag);
					else
						questTag = DAILY;
					end
				end
				if ( questTag ) then
					questTitleTag:SetText("("..questTag..")");
					questTitleTag:Show();
				else
					questTitleTag:Hide();
				end

				-- show the quest check if the quest is being watched
				if ( IsQuestWatched(questIndex) ) then
					questCheck:Show();
				else
					questCheck:Hide();
				end
			end

			-- Save if its a header or not
			questLogTitle.isHeader = isHeader;

			-- resize the title button so everything fits where it's supposed to
			QuestLogTitleButton_Resize(questLogTitle);

			-- Color the quest title and highlight according to the difficulty level
			if ( isHeader ) then
				color = QuestDifficultyColors["header"];
			else
				color = GetQuestDifficultyColor(level);
			end
			questTitleTag:SetTextColor(color.r, color.g, color.b);
			questLogTitle:SetNormalFontObject(color.font);
			questNumGroupMates:SetTextColor(color.r, color.g, color.b);
			questLogTitle.r = color.r;
			questLogTitle.g = color.g;
			questLogTitle.b = color.b;
			questLogTitle:Show();

			-- Place the highlight and lock the highlight state
			if ( questLogSelection == questIndex ) then
				--_QuestLog_HighlightQuest(questLogTitle);
			else
				questLogTitle:UnlockHighlight();
			end
		else
			questLogTitle:Hide();
		end
		displayedHeight = displayedHeight + buttonHeight;
	end
	
	
	HybridScrollFrame_Update(QuestLogScrollFrame, numEntries * buttonHeight, displayedHeight);

	-- update the control panel
	QuestLogControlPanel_UpdateState();

--
-- end org function
--

	beql.AddTags = false
	local numEntries, numQuests = GetNumQuestLogEntries()

	if beql.db.char.saved.minimized or ( numEntries == 0 ) or GetQuestLogSelection() == 0 then
		beql:Minimize()
	else
		beql:Maximize()
	end
	QuestLogCount:SetPoint("TOPLEFT", QuestLogFrame,"TOPLEFT",250,-41)
end

function beql:SetQuestLogFontSize(size)
	if not size or size == 0 then size = 12 end
	local font, fontsize, fontflags, button, buttontag
	for i = 1, #QuestLogScrollFrame.buttons do
			buttontag = getglobal("QuestLogScrollFrameButton"..i.."Tag")
			font,fontsize,fontflags = buttontag:GetFont()
			buttontag:SetFont(font,size)

			button = getglobal("QuestLogScrollFrameButton"..i.."NormalText");
			font,fontsize,fontflags = button:GetFont()
			button:SetFont(font,size) 
	end

	--font,fontsize,fontflags = QuestLogDummyText:GetFont()
	--QuestLogDummyText:SetFont(font,size + 6)
	

-- Questdiscrition short
	-- title
	font,fontsize,fontflags = QuestLogQuestTitle:GetFont()
	QuestLogQuestTitle:SetFont(font,size + 6)

	-- description
	font,fontsize,fontflags = QuestLogObjectivesText:GetFont()
	QuestLogObjectivesText:SetFont(font,size)

    -- objetives
	for i = 1, 10 do
        buttontag = getglobal("QuestLogObjective" .. i);
        font,fontsize,fontflags = buttontag:GetFont()
		buttontag:SetFont(font,size)
	end   
	
	-- need money
	font,fontsize,fontflags = QuestLogRequiredMoneyText:GetFont()
	QuestLogRequiredMoneyText:SetFont(font,size)
	
-- Questdiscrition long
	-- title
    font,fontsize,fontflags = QuestLogDescriptionTitle:GetFont()
	QuestLogDescriptionTitle:SetFont(font,size + 6)
	
	-- description
    font,fontsize,fontflags = QuestLogQuestDescription:GetFont()
	QuestLogQuestDescription:SetFont(font,size)
	
--  Questreward
	-- title
	font,fontsize,fontflags = QuestLogRewardTitleText:GetFont()
	QuestLogRewardTitleText:SetFont(font,size+6)
	
	-- items
    font,fontsize,fontflags = QuestLogItemChooseText:GetFont()
	QuestLogItemChooseText:SetFont(font,size)

    -- items
    font,fontsize,fontflags = QuestLogItemReceiveText:GetFont()
	QuestLogItemReceiveText:SetFont(font,size)

    -- spell 
    font,fontsize,fontflags = QuestLogSpellLearnText:GetFont()
	QuestLogSpellLearnText:SetFont(font,size)

    -- titles
    font,fontsize,fontflags = QuestLogPlayerTitleText:GetFont()
	QuestLogPlayerTitleText:SetFont(font,size)
 
end

--- EOF ---
